Index: /NEMO/branches/UKMO/r14075_India_uncoupled/src/OCE/SBC/tide_mod.F90
===================================================================
--- /NEMO/branches/UKMO/r14075_India_uncoupled/src/OCE/SBC/tide_mod.F90	(revision 15421)
+++ /NEMO/branches/UKMO/r14075_India_uncoupled/src/OCE/SBC/tide_mod.F90	(revision 15422)
@@ -16,5 +16,5 @@
    PUBLIC   tide_init_Wave   ! called by tideini and diaharm modules
 
-   INTEGER, PUBLIC, PARAMETER ::   jpmax_harmo = 19   !: maximum number of harmonic
+   INTEGER, PUBLIC, PARAMETER ::   jpmax_harmo = 31   !: maximum number of harmonic
 
    TYPE, PUBLIC ::    tide
@@ -41,5 +41,9 @@
 
    SUBROUTINE tide_init_Wave
+# if defined key_FES14_tides  
+#     include "tide_FES14.h90"  
+# else
 #     include "tide.h90"
+# endif
    END SUBROUTINE tide_init_Wave
 
@@ -331,4 +335,8 @@
          zf = zf * zf1 * zf1
          !
+      CASE( 20 )                 !==  formule 20,  compound waves ( 78 x 78 x 78 x 78 )  
+         zf1 = nodal_factort(78)  
+         zf  = zf1 * zf1 * zf1 * zf1  
+         ! 
       CASE( 73 )                 !==  formule 73
          zs = sin(sh_I)
Index: /NEMO/branches/UKMO/r14075_India_uncoupled/src/OCE/SBC/tideini.F90
===================================================================
--- /NEMO/branches/UKMO/r14075_India_uncoupled/src/OCE/SBC/tideini.F90	(revision 15421)
+++ /NEMO/branches/UKMO/r14075_India_uncoupled/src/OCE/SBC/tideini.F90	(revision 15422)
@@ -33,4 +33,5 @@
    INTEGER , PUBLIC ::   kt_tide         !:
    REAL(wp), PUBLIC ::   rdttideramp     !:
+   REAL(wp), PUBLIC ::   dn_love_number  !:
    REAL(wp), PUBLIC ::   rn_scal_load    !:
    CHARACTER(lc), PUBLIC ::   cn_tide_load   !: 
@@ -54,5 +55,5 @@
       !
       NAMELIST/nam_tide/ln_tide, ln_tide_pot, ln_scal_load, ln_read_load, cn_tide_load, &
-                  &     ln_tide_ramp, rn_scal_load, rdttideramp, clname
+                  &     ln_tide_ramp, rn_scal_load, rdttideramp, dn_love_number, clname
       !!----------------------------------------------------------------------
       !
@@ -78,4 +79,5 @@
             WRITE(numout,*) '         Read load potential from file           ln_read_load = ', ln_read_load
             WRITE(numout,*) '         Apply ramp on tides at startup          ln_tide_ramp = ', ln_tide_ramp
+            WRITE(numout,*) '                                              dn_love_number  = ', dn_love_number
             WRITE(numout,*) '         Fraction of SSH used in scal. approx.   rn_scal_load = ', rn_scal_load
             WRITE(numout,*) '         Duration (days) of ramp                 rdttideramp  = ', rdttideramp
@@ -99,4 +101,6 @@
       END DO
       !       
+      IF (ln_tide .and.lwp) WRITE(numout,*) 'nb_harmo     = ', nb_harmo
+
       ! Ensure that tidal components have been set in namelist_cfg
       IF( nb_harmo == 0 )   CALL ctl_stop( 'tide_init : No tidal components set in nam_tide' )
Index: /NEMO/branches/UKMO/r14075_India_uncoupled/src/OCE/USR/usrdef_istate.F90
===================================================================
--- /NEMO/branches/UKMO/r14075_India_uncoupled/src/OCE/USR/usrdef_istate.F90	(revision 15421)
+++ /NEMO/branches/UKMO/r14075_India_uncoupled/src/OCE/USR/usrdef_istate.F90	(revision 15422)
@@ -62,18 +62,6 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-               pts(ji,jj,jk,jp_tem) =  (  (  16. - 12. * TANH( (pdept(ji,jj,jk) - 400) / 700 ) )   &
-                    &           * (-TANH( (500. - pdept(ji,jj,jk)) / 150. ) + 1.) / 2.             &
-                    &           + ( 15. * ( 1. - TANH( (pdept(ji,jj,jk)-50.) / 1500.) )            &
-                    &           - 1.4 * TANH((pdept(ji,jj,jk)-100.) / 100.)                        &
-                    &           + 7.  * (1500. - pdept(ji,jj,jk) ) / 1500.)                        &
-                    &           * (-TANH( (pdept(ji,jj,jk) - 500.) / 150.) + 1.) / 2.  ) * ptmask(ji,jj,jk)
-
-               pts(ji,jj,jk,jp_sal) =  (  (  36.25 - 1.13 * TANH( (pdept(ji,jj,jk) - 305) / 460 ) )  &
-                    &         * (-TANH((500. - pdept(ji,jj,jk)) / 150.) + 1.) / 2                  &
-                    &         + ( 35.55 + 1.25 * (5000. - pdept(ji,jj,jk)) / 5000.                 &
-                    &         - 1.62 * TANH( (pdept(ji,jj,jk) - 60.  ) / 650. )                    &
-                    &         + 0.2  * TANH( (pdept(ji,jj,jk) - 35.  ) / 100. )                    &
-                    &         + 0.2  * TANH( (pdept(ji,jj,jk) - 1000.) / 5000.) )                  &
-                    &         * (-TANH( (pdept(ji,jj,jk) - 500.) / 150.) + 1.) / 2  ) * ptmask(ji,jj,jk)
+               pts(ji,jj,jk,jp_tem) = 20._wp * ptmask(ji,jj,jk)  
+               pts(ji,jj,jk,jp_sal) = 36.25_wp * ptmask(ji,jj,jk)
             END DO
          END DO
Index: /NEMO/branches/UKMO/r14075_India_uncoupled/src/OCE/USR/usrdef_sbc.F90
===================================================================
--- /NEMO/branches/UKMO/r14075_India_uncoupled/src/OCE/USR/usrdef_sbc.F90	(revision 15421)
+++ /NEMO/branches/UKMO/r14075_India_uncoupled/src/OCE/USR/usrdef_sbc.F90	(revision 15422)
@@ -1,32 +1,44 @@
 MODULE usrdef_sbc
    !!======================================================================
-   !!                     ***  MODULE  usrdef_sbc  ***
-   !!
-   !!                     ===  GYRE configuration  ===
+   !!                       ***  MODULE usrdef_sbc  *** 
+   !!  
+   !!                  ===  AMM7_SURGE configuration  ===
    !!
    !! User defined :   surface forcing of a user configuration
    !!======================================================================
    !! History :  4.0   ! 2016-03  (S. Flavoni, G. Madec)  user defined interface
+   !!            4.0   ! 2017-12  (C. O'Neill)  add necessary options for surge work - either no fluxes  
+   !!                                           (for tide-only run) or wind and pressure only
    !!----------------------------------------------------------------------
 
    !!----------------------------------------------------------------------
-   !!   usrdef_sbc    : user defined surface bounday conditions in GYRE case
+   !!   usrdef_sbc    : user defined surface bounday conditions in LOCK_EXCHANGE case
    !!----------------------------------------------------------------------
-   USE oce            ! ocean dynamics and tracers
-   USE dom_oce        ! ocean space and time domain
-   USE sbc_oce        ! Surface boundary condition: ocean fields
-   USE phycst         ! physical constants
+   USE oce             ! ocean dynamics and tracers 
+   USE dom_oce         ! ocean space and time domain 
+   USE sbc_oce         ! Surface boundary condition: ocean fields 
+   USE sbc_ice         ! Surface boundary condition: ocean fields 
+   USE fldread         ! read input fields 
+   USE phycst          ! physical constants 
+   USE lib_fortran     ! Fortran utilities (allows no signed zero when 'key_nosignedzero' defined)
    !
-   USE in_out_manager ! I/O manager
-   USE lib_mpp        ! distribued memory computing library
-   USE lbclnk         ! ocean lateral boundary conditions (or mpp link)
-   USE lib_fortran    !
+   USE in_out_manager  ! I/O manager 
+   USE iom 
+   USE lbclnk          ! ocean lateral boundary conditions (or mpp link) 
+   USE lib_mpp         ! distribued memory computing library 
+   !USE wrk_nemo       ! work arrays 
+   USE timing         ! Timing 
+   USE prtctl         ! Print control
 
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC   usrdef_sbc_oce       ! routine called in sbcmod module
-   PUBLIC   usrdef_sbc_ice_tau   ! routine called by icestp.F90 for ice dynamics
-   PUBLIC   usrdef_sbc_ice_flx   ! routine called by icestp.F90 for ice thermo
+   PUBLIC   usrdef_sbc_oce    ! routine called in sbcmod module 
+   PUBLIC   usrdef_sbc_ice_tau  ! routine called by sbcice_lim.F90 for ice dynamics 
+   PUBLIC   usrdef_sbc_ice_flx  ! routine called by sbcice_lim.F90 for ice thermo 
+   !                                  !!* Namelist namsbc_usr 
+   REAL(wp) ::   rn_vfac     ! multiplication factor for ice/ocean velocity in the calculation of wind stress (clem) 
+   REAL(wp) ::   rn_charn_const  
+   LOGICAL  ::   ln_use_sbc  ! Surface fluxes on or not
 
    !! * Substitutions
@@ -43,182 +55,46 @@
       !!                    ***  ROUTINE usrdef_sbc  ***
       !!              
-      !! ** Purpose :   provide at each time-step the GYRE surface boundary
+      !! ** Purpose :   provide at each time-step the surface boundary
       !!              condition, i.e. the momentum, heat and freshwater fluxes.
       !!
-      !! ** Method  :   analytical seasonal cycle for GYRE configuration.
+      !! ** Method  :   all 0 fields, for AMM7_SURGE case
       !!                CAUTION : never mask the surface stress field !
       !!
-      !! ** Action  : - set the ocean surface boundary condition, i.e.   
+      !! ** Action  : - if tide-only case - set to ZERO all the ocean surface boundary condition, i.e.
       !!                   utau, vtau, taum, wndm, qns, qsr, emp, sfx
-      !!
-      !! Reference : Hazeleger, W., and S. Drijfhout, JPO, 30, 677-695, 2000.
+      !!              - if tide+surge case - read in wind and air pressure      !!
       !!----------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt   ! ocean time step
-      !!
-      INTEGER  ::   ji, jj                 ! dummy loop indices
-      INTEGER  ::   zyear0                 ! initial year 
-      INTEGER  ::   zmonth0                ! initial month
-      INTEGER  ::   zday0                  ! initial day
-      INTEGER  ::   zday_year0             ! initial day since january 1st
-      REAL(wp) ::   ztau     , ztau_sais   ! wind intensity and of the seasonal cycle
-      REAL(wp) ::   ztime                  ! time in hour
-      REAL(wp) ::   ztimemax , ztimemin    ! 21th June, and 21th decem. if date0 = 1st january
-      REAL(wp) ::   ztimemax1, ztimemin1   ! 21th June, and 21th decem. if date0 = 1st january
-      REAL(wp) ::   ztimemax2, ztimemin2   ! 21th June, and 21th decem. if date0 = 1st january
-      REAL(wp) ::   ztaun                  ! intensity
-      REAL(wp) ::   zemp_s, zemp_n, zemp_sais, ztstar
-      REAL(wp) ::   zcos_sais1, zcos_sais2, ztrp, zconv, t_star
-      REAL(wp) ::   zsumemp, zsurf
-      REAL(wp) ::   zrhoa  = 1.22         ! Air density kg/m3
-      REAL(wp) ::   zcdrag = 1.5e-3       ! drag coefficient
-      REAL(wp) ::   ztx, zty, zmod, zcoef ! temporary variables
-      REAL(wp) ::   zyydd                 ! number of days in one year
+
+      INTEGER  ::   ios      ! Local integer output status for namelist read 
+      ! 
+      CHARACTER(len=100) ::  cn_dir   !   Root directory for location of flux files 
+      TYPE(FLD_N) ::   sn_wndi, sn_wndj                        ! informations about the fields to be read 
+
+      NAMELIST/namsbc_usr/ ln_use_sbc, cn_dir , rn_vfac,  & 
+         &                   sn_wndi, sn_wndj, rn_charn_const
       !!---------------------------------------------------------------------
-      zyydd = REAL(nyear_len(1),wp)
+      ! 
+      IF( kt == nit000 ) THEN 
+          
+          
+         REWIND( numnam_cfg )              ! Namelist namsbc_usr in configuration namelist 
+         READ  ( numnam_cfg, namsbc_usr, IOSTAT = ios, ERR = 902 ) 
+902      IF( ios /= 0 ) CALL ctl_nam ( ios , 'namsbc_surge in configuration namelist' )
 
-      ! ---------------------------- !
-      !  heat and freshwater fluxes  !
-      ! ---------------------------- !
-      !same temperature, E-P as in HAZELEGER 2000
+         IF(lwm) WRITE( numond, namsbc_usr )
+         IF(lwp) WRITE(numout,*)' usr_sbc : AMM7_SURGE tide only case: NO surface forcing' 
+         IF(lwp) WRITE(numout,*)' ~~~~~~~~~~~   utau = vtau = taum = wndm = qns = qsr = emp = sfx = 0'
 
-      zyear0     =   ndate0 / 10000                             ! initial year
-      zmonth0    = ( ndate0 - zyear0 * 10000 ) / 100            ! initial month
-      zday0      =   ndate0 - zyear0 * 10000 - zmonth0 * 100    ! initial day betwen 1 and 30
-      zday_year0 = ( zmonth0 - 1 ) * 30.+zday0                  ! initial day betwen 1 and 360
-
-      ! current day (in hours) since january the 1st of the current year
-      ztime = REAL( kt ) * rdt / (rmmss * rhhmm)   &       !  total incrementation (in hours)
-         &      - (nyear  - 1) * rjjhh * zyydd             !  minus years since beginning of experiment (in hours)
-
-      ztimemax1 = ((5.*30.)+21.)* 24.                      ! 21th june     at 24h in hours
-      ztimemin1 = ztimemax1 + rjjhh * zyydd / 2            ! 21th december        in hours
-      ztimemax2 = ((6.*30.)+21.)* 24.                      ! 21th july     at 24h in hours
-      ztimemin2 = ztimemax2 - rjjhh * zyydd / 2            ! 21th january         in hours
-      !                                                    ! NB: rjjhh * zyydd / 4 = one seasonal cycle in hours
-
-      ! amplitudes
-      zemp_S    = 0.7       ! intensity of COS in the South
-      zemp_N    = 0.8       ! intensity of COS in the North
-      zemp_sais = 0.1
-      zTstar    = 28.3      ! intemsity from 28.3 a -5 deg
-
-      ! 1/2 period between 21th June and 21th December and between 21th July and 21th January
-      zcos_sais1 = COS( (ztime - ztimemax1) / (ztimemin1 - ztimemax1) * rpi ) 
-      zcos_sais2 = COS( (ztime - ztimemax2) / (ztimemax2 - ztimemin2) * rpi )
-
-      ztrp= - 40.e0        ! retroaction term on heat fluxes (W/m2/K)
-      zconv = 3.16e-5      ! convertion factor: 1 m/yr => 3.16e-5 mm/s
-      DO jj = 1, jpj
-         DO ji = 1, jpi
-            ! domain from 15 deg to 50 deg between 27 and 28  degC at 15N, -3
-            ! and 13 degC at 50N 53.5 + or - 11 = 1/4 period :
-            ! 64.5 in summer, 42.5 in winter
-            t_star = zTstar * ( 1. + 1. / 50. * zcos_sais2 )                &
-               &                    * COS( rpi * (gphit(ji,jj) - 5.)               &
-               &                    / ( 53.5 * ( 1 + 11 / 53.5 * zcos_sais2 ) * 2.) )
-            ! 23.5 deg : tropics
-            qsr (ji,jj) =  230 * COS( 3.1415 * ( gphit(ji,jj) - 23.5 * zcos_sais1 ) / ( 0.9 * 180 ) )
-            qns (ji,jj) = ztrp * ( tsb(ji,jj,1,jp_tem) - t_star ) - qsr(ji,jj)
-            IF( gphit(ji,jj) >= 14.845 .AND. 37.2 >= gphit(ji,jj) ) THEN    ! zero at 37.8 deg, max at 24.6 deg
-               emp  (ji,jj) =   zemp_S * zconv   &
-                  &         * SIN( rpi / 2 * (gphit(ji,jj) - 37.2) / (24.6 - 37.2) )  &
-                  &         * ( 1 - zemp_sais / zemp_S * zcos_sais1)
-            ELSE
-               emp (ji,jj) =  - zemp_N * zconv   &
-                  &         * SIN( rpi / 2 * (gphit(ji,jj) - 37.2) / (46.8 - 37.2) )  &
-                  &         * ( 1 - zemp_sais / zemp_N * zcos_sais1 )
-            ENDIF
-         END DO
-      END DO
-
-      zsumemp = GLOB_SUM( 'usrdef_sbc', emp  (:,:)   ) 
-      zsurf   = GLOB_SUM( 'usrdef_sbc', tmask(:,:,1) ) 
-      zsumemp = zsumemp / zsurf         ! Default GYRE configuration
-
-      ! freshwater (mass flux) and update of qns with heat content of emp
-      emp (:,:) = emp(:,:) - zsumemp * tmask(:,:,1)        ! freshwater flux (=0 in domain average)
-      sfx (:,:) = 0.0_wp                                   ! no salt flux
-      qns (:,:) = qns(:,:) - emp(:,:) * sst_m(:,:) * rcp   ! evap and precip are at SST
-
-
-      ! ---------------------------- !
-      !       momentum fluxes        !
-      ! ---------------------------- !
-      ! same wind as in Wico
-      !test date0 : ndate0 = 010203
-      zyear0  =   ndate0 / 10000
-      zmonth0 = ( ndate0 - zyear0 * 10000 ) / 100
-      zday0   =   ndate0 - zyear0 * 10000 - zmonth0 * 100
-      !Calculates nday_year, day since january 1st
-      zday_year0 = (zmonth0-1)*30.+zday0
-
-      !accumulates days of previous months of this year
-      ! day (in hours) since january the 1st
-      ztime = FLOAT( kt ) * rdt / (rmmss * rhhmm)  &  ! incrementation in hour
-         &     - (nyear - 1) * rjjhh * zyydd          !  - nber of hours the precedent years
-      ztimemax = ((5.*30.)+21.)* 24.               ! 21th june     in hours
-      ztimemin = ztimemax + rjjhh * zyydd / 2      ! 21th december in hours
-      !                                            ! NB: rjjhh * zyydd / 4 = 1 seasonal cycle in hours
-
-      ! mean intensity at 0.105 ; srqt(2) because projected with 45deg angle
-      ztau = 0.105 / SQRT( 2. )
-      ! seasonal oscillation intensity
-      ztau_sais = 0.015
-      ztaun = ztau - ztau_sais * COS( (ztime - ztimemax) / (ztimemin - ztimemax) * rpi )
-      DO jj = 1, jpj
-         DO ji = 1, jpi
-           ! domain from 15deg to 50deg and 1/2 period along 14deg
-           ! so 5/4 of half period with seasonal cycle
-           utau(ji,jj) = - ztaun * SIN( rpi * (gphiu(ji,jj) - 15.) / (29.-15.) )
-           vtau(ji,jj) =   ztaun * SIN( rpi * (gphiv(ji,jj) - 15.) / (29.-15.) )
-         END DO
-      END DO
-
-      ! module of wind stress and wind speed at T-point
-      zcoef = 1. / ( zrhoa * zcdrag ) 
-      DO jj = 2, jpjm1
-         DO ji = fs_2, fs_jpim1   ! vect. opt.
-            ztx = utau(ji-1,jj  ) + utau(ji,jj) 
-            zty = vtau(ji  ,jj-1) + vtau(ji,jj) 
-            zmod = 0.5 * SQRT( ztx * ztx + zty * zty )
-            taum(ji,jj) = zmod
-            wndm(ji,jj) = SQRT( zmod * zcoef )
-         END DO
-      END DO
-      CALL lbc_lnk_multi( 'usrdef_sbc', taum(:,:), 'T', 1. , wndm(:,:), 'T', 1. )
-
-      ! ---------------------------------- !
-      !  control print at first time-step  !
-      ! ---------------------------------- !
-      IF( kt == nit000 .AND. lwp ) THEN 
-         WRITE(numout,*)
-         WRITE(numout,*)'usrdef_sbc_oce : analytical surface fluxes for GYRE configuration'               
-         WRITE(numout,*)'~~~~~~~~~~~ ' 
-         WRITE(numout,*)'           nyear      = ', nyear
-         WRITE(numout,*)'           nmonth     = ', nmonth
-         WRITE(numout,*)'           nday       = ', nday
-         WRITE(numout,*)'           nday_year  = ', nday_year
-         WRITE(numout,*)'           ztime      = ', ztime
-         WRITE(numout,*)'           ztimemax   = ', ztimemax
-         WRITE(numout,*)'           ztimemin   = ', ztimemin
-         WRITE(numout,*)'           ztimemax1  = ', ztimemax1
-         WRITE(numout,*)'           ztimemin1  = ', ztimemin1
-         WRITE(numout,*)'           ztimemax2  = ', ztimemax2
-         WRITE(numout,*)'           ztimemin2  = ', ztimemin2
-         WRITE(numout,*)'           zyear0     = ', zyear0
-         WRITE(numout,*)'           zmonth0    = ', zmonth0
-         WRITE(numout,*)'           zday0      = ', zday0
-         WRITE(numout,*)'           zday_year0 = ', zday_year0
-         WRITE(numout,*)'           zyydd      = ', zyydd
-         WRITE(numout,*)'           zemp_S     = ', zemp_S
-         WRITE(numout,*)'           zemp_N     = ', zemp_N
-         WRITE(numout,*)'           zemp_sais  = ', zemp_sais
-         WRITE(numout,*)'           zTstar     = ', zTstar
-         WRITE(numout,*)'           zsumemp    = ', zsumemp
-         WRITE(numout,*)'           zsurf      = ', zsurf
-         WRITE(numout,*)'           ztrp       = ', ztrp
-         WRITE(numout,*)'           zconv      = ', zconv
-         WRITE(numout,*)'           ndastp     = ', ndastp
-         WRITE(numout,*)'           adatrj     = ', adatrj
+         utau(:,:) = 0._wp 
+         vtau(:,:) = 0._wp 
+         taum(:,:) = 0._wp 
+         wndm(:,:) = 0._wp 
+         ! 
+         emp (:,:) = 0._wp 
+         sfx (:,:) = 0._wp 
+         qns (:,:) = 0._wp 
+         qsr (:,:) = 0._wp 
+         !
       ENDIF
       !
@@ -231,8 +107,6 @@
 
 
-   SUBROUTINE usrdef_sbc_ice_flx( kt, phs, phi )
+   SUBROUTINE usrdef_sbc_ice_flx( kt )
       INTEGER, INTENT(in) ::   kt   ! ocean time step
-      REAL(wp), DIMENSION(:,:,:), INTENT(in)  ::   phs    ! snow thickness
-      REAL(wp), DIMENSION(:,:,:), INTENT(in)  ::   phi    ! ice thickness
    END SUBROUTINE usrdef_sbc_ice_flx
 
Index: /NEMO/branches/UKMO/r14075_India_uncoupled/src/OCE/par_oce.F90
===================================================================
--- /NEMO/branches/UKMO/r14075_India_uncoupled/src/OCE/par_oce.F90	(revision 15421)
+++ /NEMO/branches/UKMO/r14075_India_uncoupled/src/OCE/par_oce.F90	(revision 15422)
@@ -64,4 +64,6 @@
    INTEGER, PUBLIC, PARAMETER ::   jp_tem = 1    !: indice for temperature
    INTEGER, PUBLIC, PARAMETER ::   jp_sal = 2    !: indice for salinity
+   INTEGER, PUBLIC, PARAMETER ::   jp_dep = 3    !: indice for depth  
+   INTEGER, PUBLIC, PARAMETER ::   jp_msk = 4    !: indice for mask
 
    !!----------------------------------------------------------------------
Index: /NEMO/branches/UKMO/r14075_India_uncoupled/src/OCE/step.F90
===================================================================
--- /NEMO/branches/UKMO/r14075_India_uncoupled/src/OCE/step.F90	(revision 15421)
+++ /NEMO/branches/UKMO/r14075_India_uncoupled/src/OCE/step.F90	(revision 15422)
@@ -206,4 +206,6 @@
                          CALL dia_ar5 ( kstp )        ! ar5 diag
       IF( ln_diaptr  )   CALL dia_ptr                 ! Poleward adv/ldf TRansports diagnostics
+      IF( lk_diaharm_fast )                           &  
+            &            CALL dia_harm_fast( kstp )   ! Tidal harmonic analysis - restart and faster version 
       IF( ln_diaharm )   CALL dia_harm( kstp )        ! Tidal harmonic analysis
                          CALL dia_wri ( kstp )        ! ocean model: outputs
Index: /NEMO/branches/UKMO/r14075_India_uncoupled/src/OCE/step_oce.F90
===================================================================
--- /NEMO/branches/UKMO/r14075_India_uncoupled/src/OCE/step_oce.F90	(revision 15421)
+++ /NEMO/branches/UKMO/r14075_India_uncoupled/src/OCE/step_oce.F90	(revision 15422)
@@ -79,4 +79,5 @@
    USE diahth          ! thermocline depth                (dia_hth routine)
    USE diahsb          ! heat, salt and volume budgets    (dia_hsb routine)
+   USE diaharm_fast    ! harmonic analysis of tides (harm_ana routine)
    USE diaharm
    USE diacfl
Index: /NEMO/branches/UKMO/r14075_India_uncoupled/src/OCE/stpctl.F90
===================================================================
--- /NEMO/branches/UKMO/r14075_India_uncoupled/src/OCE/stpctl.F90	(revision 15421)
+++ /NEMO/branches/UKMO/r14075_India_uncoupled/src/OCE/stpctl.F90	(revision 15422)
@@ -126,5 +126,5 @@
          zmax(1) = MAXVAL(  ABS( sshn(:,:) )  )                               ! ssh max
       ENDIF
-      zmax(2) = MAXVAL(  ABS( un(:,:,:) )  )                                  ! velocity max (zonal only)
+      zmax(2) = MAXVAL(  un(:,:,:)*un(:,:,:) + vn(:,:,:)*vn(:,:,:)  )         ! velocity max
       llmsk(:,:,:) = tmask(:,:,:) == 1._wp
       IF( COUNT( llmsk(:,:,:) ) > 0 ) THEN   ! avoid huge values sent back for land processors...      
@@ -167,5 +167,5 @@
       !                                   !==  error handling  ==!
       IF(   zmax(1) >   20._wp .OR.   &                    ! too large sea surface height ( > 20 m )
-         &  zmax(2) >   10._wp .OR.   &                    ! too large velocity ( > 10 m/s)
+         &  zmax(2) >  100._wp .OR.   &                    ! too large velocity ( > 10 m/s)
          &  zmax(3) >=   0._wp .OR.   &                    ! negative or zero sea surface salinity
          &  zmax(4) >= 100._wp .OR.   &                    ! too large sea surface salinity ( > 100 )
@@ -177,5 +177,5 @@
             IF( lwm .AND. kt /= nitend )   istatus = NF90_CLOSE(idrun)
             CALL mpp_maxloc( 'stpctl', ABS(sshn)        , ssmask(:,:)  , zzz, ih(1:2)  )   ;   ih(3) = 0
-            CALL mpp_maxloc( 'stpctl', ABS(un)          , umask (:,:,:), zzz, iu  )
+            CALL mpp_maxloc( 'stpctl', un*un + vn*vn    , umask (:,:,:), zzz, iu  )
             CALL mpp_minloc( 'stpctl', tsn(:,:,:,jp_sal), tmask (:,:,:), zzz, is1 )
             CALL mpp_maxloc( 'stpctl', tsn(:,:,:,jp_sal), tmask (:,:,:), zzz, is2 )
@@ -192,5 +192,5 @@
          ELSE
             ih(1:2)= MAXLOC( ABS( sshn(:,:)   )                              ) + (/ nimpp - 1, njmpp - 1    /)   ;   ih(3) = 0
-            iu(:)  = MAXLOC( ABS( un  (:,:,:) )                              ) + (/ nimpp - 1, njmpp - 1, 0 /)
+            iu(:)  = MAXLOC( un(:,:,:)*un(:,:,:) + vn(:,:,:)*vn(:,:,:)       ) + (/ nimpp - 1, njmpp - 1, 0 /)
             is1(:) = MINLOC( tsn(:,:,:,jp_sal), mask = tmask(:,:,:) == 1._wp ) + (/ nimpp - 1, njmpp - 1, 0 /)
             is2(:) = MAXLOC( tsn(:,:,:,jp_sal), mask = tmask(:,:,:) == 1._wp ) + (/ nimpp - 1, njmpp - 1, 0 /)
@@ -200,5 +200,5 @@
          WRITE(ctmp1,*) ' stp_ctl: |ssh| > 20 m  or  |U| > 10 m/s  or  S <= 0  or  S >= 100  or  NaN encounter in the tests'
          CALL wrt_line(ctmp2, kt, ' |ssh| max ',   zmax(1), ih , iareasum(1), iareamin(1), iareamax(1) ) 
-         CALL wrt_line(ctmp3, kt, ' |U|   max ',   zmax(2), iu , iareasum(2), iareamin(2), iareamax(2) ) 
+         CALL wrt_line(ctmp3, kt, ' Vel2  max ',   zmax(2), iu , iareasum(2), iareamin(2), iareamax(2) ) 
          CALL wrt_line(ctmp4, kt, ' Sal   min ', - zmax(3), is1, iareasum(3), iareamin(3), iareamax(3) ) 
          CALL wrt_line(ctmp5, kt, ' Sal   max ',   zmax(4), is2, iareasum(4), iareamin(4), iareamax(4) ) 
@@ -226,5 +226,5 @@
       ENDIF
       !
-9500  FORMAT(' it :', i8, '    |ssh|_max: ', D23.16, ' |U|_max: ', D23.16,' S_min: ', D23.16,' S_max: ', D23.16)
+9500  FORMAT(' it :', i8, '    |ssh|_max: ', D23.16, ' Vel2_max: ', D23.16,' S_min: ', D23.16,' S_max: ', D23.16)
       !
    END SUBROUTINE stp_ctl
